#include "dic.h"

char *index(), *sprintf();
FILE *fopen();
long findWord();

FixPronounce(s) char *s; {
	char p[200];
	sscanf(s,"%*[^;];%[^\n]",p);
	sprintf(s,"(%s)\n",p);
}

sprintDef(f,offset,out,w) FILE *f,*out; long offset; char *w; {
	char s[200];
	if (!f) return;
	fseek(f,offset-2,0); /* -2 backs up to "F;" of def */
	while (fgets(s,sizeof s,f) and strncmp(s,"F;",2)) {
	    More:
		fputs(s,out);
		*s = '\0';
	}
	if (strncmp(s,"F;",2)==0 and Strncmp(s+2,w,strlen(w))==0)
		goto More;
	fclose(f);
}

FixMini(s) char *s; { /* turn occurences of "[mini ...]" to "..." */
	char *p = s;
	while (*s) {
		if (strncmp(s,"[mini",5)==0){
			s += 5;
			while (*s && *s == ' ') ++s;
			while (*s && *s != ']')
				*p++ = *s++;
			if (*s == ']') ++s;
		}
		*p = *s;
		if (*s) ++p, ++s;
	}
	*p = '\0';
}

FixText(s) char *s; {
	substitute(s,"[italic ", "i[");
	substitute(s,"i[esp]", "esp");
	substitute(s,"[bold ", "i[");
	substitute(s,"b[syn]", "Syn:");
	substitute(s,"b[syn]", "Syn:");
	substitute(s," :", ":");
	FixMini(s);
}

Indent(f,n) FILE *f; { while (n-->0) putc(' ',f); }
		
printDef(f,offset,out,w,max) FILE *f,*out; long offset; char *w; {
	char s[200];
	int def = 0;
	int indent = 3;
	int n = 0;
	int wl = strlen(w);

	if (!f) return;
	fseek(f,offset-2,0); /* -2 backs up to "F;" of def */
	while (fgets(s,sizeof s,f)) {
		if (*s == 'F') { /* entry */
			char word[100], split[20], part[10], *p = word;
			*word = *split = *part = '\0';
			if (++n > max) goto Out;
			/*          word; ....;  ....;  split;part */
			sscanf(s,"F;%[^;];%*[^;];%*[^;];%[^;];%[^;]",word,split,part);
			if (*p == '-') ++p;	/* "def zym" bug.  yich. */
			if (Strncmp(p,w,wl)) goto Out;
			if (n > 1) fprintf(out,"\n");
			fprintf(out,"%s (%s)\n",hyphen(word,split),part);
			def = 0;
			indent = 3;
			goto Continue;
		}
		if (*s == 'D') { /* definition */
			char n[5]; int i=0, indent = 3;
			char sub[5],subsub[5],part[5],text[200];
			int cont = 0;
			*n = *sub = *subsub = *part = '\0';
			sscanf(s,"D;%[^;];%[^;];%[^;];%[^;];%[^\n]",n,sub,subsub,part,text);
			if (*n) i = atoi(n);
			if (i && i != def)
				fprintf(out,"%d) ",i);
			else	Indent(out,indent);
			def = i;
			if (*sub || *subsub) {
				fprintf(out,"%s%s) ",sub,subsub);
				indent += strlen(sub) + strlen(subsub) + 2;
			}
			if (*part) fprintf(out,"%s, ",part);
			FixText(text);
			i = strlen(text);
			if (i && text[i-1] == '#'){
				text[i-1] = '\0';
				cont = 1;
			}
			fprintf(out,"%s\n",text);
			while (cont && fgets(text,sizeof text,f)) {
				FixText(text);
				i = strlen(text);
				if (i && text[i-2] == '#')
					text[i-2] = ' ', cont = 1;
				else cont = 0;
				Indent(out,indent);
				fprintf(out,"%s",text);
			}	
			goto Continue;
		}
		indent = 3;
		if (*s == 'E') { /* etymology */
			int i, cont=0;
			FixText(s);
			i = strlen(s);
			if (i && s[i-2] == '#')
				s[i-2] = ' ', cont = 1;
			fprintf(out,"Etymology: %s",s+2);
			while (cont && fgets(s,sizeof s,f)){
				FixText(s);
				i = strlen(s);
				if (i && s[i-2] == '#')
					s[i-2] = ' ', cont = 1;
				else cont = 0;
				Indent(out,3);
				fprintf(out,"%s",s);
			}
			goto Continue;
		}
		if (*s == 'S') { /* synonyms */
			int i, cont=0;
			FixText(s);
			i = strlen(s);
			if (i && s[i-2] == '#')
				s[i-2] = ' ', cont = 1;
			fprintf(out,"Synonyms: %s",s+2);
			while (cont && fgets(s,sizeof s,f)){
				FixText(s);
				i = strlen(s);
				if (i && s[i-2] == '#')
					s[i-2] = ' ', cont = 1;
				else cont = 0;
				Indent(out,3);
				fprintf(out,"%s",s);
			}
			goto Continue;
		}
		if (*s == 'V'){ /* verb form */
			char word[100],split[10];
			sscanf(s+2,"%[^;];%[^;];",word,split);
			fprintf(out,"%s ",hyphen(word,split));
			goto Continue;
		}
		if (*s == 'X'){ /* synonym */
			char word[100];
			sscanf(s+2,"%[^;]",word);
			fprintf(out,"syn. see %s; ",word);
			goto Continue;
		}
		if (*s == 'R'){ /* related forms */
			char word[100],split[10],part[10];
			sscanf(s+2,"%[^;];%[^;];%[^;]",word,split,part);
			fprintf(out," -- %s",hyphen(word,split));
			if (*part) fprintf(out,", %s\n",part);
			goto Continue;
		}
		if (*s == 'L'){
			char *p; int i = 4;
			FixText(s);
			for (p=s; i>0 && *p; p++)
				if (*p == ';') --i;
			if (*p == ';') ++p;
			Indent(out,indent);
			fprintf(out,"%s",p);
			goto Continue;
		}
		if (*s == 'P') /* pronunciation */
			FixPronounce(s);
		else FixText(s);
		fputs(s,out);
	    Continue:
		*s = '\0';
	}
   Out:	fclose(f);
}

int Simple = 0;

PrintDef(w,offset,n) Char *w; long offset; {
	int (*f)() = Simple? sprintDef : printDef;
	if (offset == -1) return fprintf(stderr,"%s can't find '%s'\n",av0,w);
	f(DefFile(w),offset,stdout,w,n);	
}

FindWord(w,max)
	Char *w;
{
	FILE *IndexFile(), *f;
   log(w);
	strtolower(w);
	if (f = IndexFile(w)) PrintDef(w,findWord(f,w),max), fclose(f);
}

#define flip(v) v = !v

use(){
	fprintf(stderr,"Use: %s [-n max] [-s] words ...\n",av0);
	fprintf(stderr,"-n sets the maximum number of definitions to print (default = lots)\n");
	fprintf(stderr,"-s means print in simple (unformatted) format\n");
	exit(1);
}

main(ac,av) Char *av[]; {
	Int i;
	int MaxDefs = 9999;
	for_each_argument{
	Case 's': flip(Simple);
	Case 'n': MaxDefs = atoi(argument);
	Default : use();
	}
   /*StartLog("/u0/mike/weblog");*/
	if (i==ac){
		char s[100];
		while(gets(s)) FindWord(s,MaxDefs);
	} else for (;i<ac;i++)
		FindWord(av[i],MaxDefs);
   EndLog();
	exit(0);
}
