#include "dic.h"
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>

#d MAX 1024
#d min(a,b) (a<b)? a : b

static char *rindex(s,t,c) char *s,*t,c; {
	char *p = t;
	while (p > s && *p != c) --p;
	return (*p == c)? p : (char *)0;
}

long
findWord(f,word)
	FILE *f;
	char *word;
/*
 * Binary search for 'word' in 'f', and return offset for 'word'.
 * ('f' is a sorted list of 'word offset' pairs).
 * If not found, return -1.
 * 'w' may be a prefixed match; 'f' is left pointing to the
 * next line after the first one containing 'w'.
 */
{
	Char *c, *lp;
	char s[MAX];
	struct stat sb;
	off_t mid, top, bot;
	long offset = -1L;
	int wl = strlen(word);

	if (fstat(fileno(f),&sb) < 0 or (top=sb.st_size)==0) return offset;
	bot = 0;
	while (top >= bot) {
		mid = (top+bot)/2;
		fseek(f,mid,L_SET);
		/* For first tag scan to next '\n'. */
		if (mid>0 and !fgets(s,sizeof s,f)) goto SomeLeft;
		/* get the line itself */
		if (!fgets(s,sizeof s,f)) goto SomeLeft;
		for (c=s, lp=word; *c and *lp == *c; c++,lp++) ;
		if (!*lp) break;
		if (*lp > *c) bot = mid + 1;
		else
	    SomeLeft:	top = mid - 1;
	}
	if (top < bot) return offset;
	/* Found it */
	while (*c && !space(*c)) ++c;
	while space(*c) ++c;
	sscanf(c,"%D",&offset);

	/* back up and make sure we found the first one */
   Again:
	while (mid > 0){
		int n = min(mid,800);
		mid -= n;
		fseek(f,mid,L_SET);
		if (fread(s,sizeof(char),n,f) == n && fgets(s+n,80,f)){
			long l;
			char *p=s+strlen(s);
		    for (;;){
			p = rindex(s,p,'\n');
			if (!p) goto Again;
			*p = '\0';
			p = rindex(s,p,'\n');
			if (!p) goto Again;
			p++;
			if (Strncmp(p,word,wl)) return offset;
			l = 0L;
			if (sscanf(p,"%*s %D",&l) && l != 0 && l < offset)
				offset = l;
		    }
		}
	}
	return offset;
}
